define _DBGENG_H

interface IDebugAdvanced extends IUnknown
  GUID			F2DF5F53-071F-47BD-9DE6-5734C3FED689
  GetThreadContext	stdmethod(IDebugAdvanced *THIS, OUT PVOID Context, IN ULONG ContextSize)
  SetThreadContext	stdmethod(IDebugAdvanced *THIS, IN PVOID Context, IN ULONG ContextSize)
endi

interface IDebugAdvanced2 extends IDebugAdvanced
  GUID				716D14C9-119B-4BA5-AF1F-0890E672416A
  Request			stdmethod(IDebugAdvanced2 *THIS, IN ULONG Request, IN OPTIONAL PVOID InBuffer, IN ULONG InBufferSize, OUT OPTIONAL PVOID OutBuffer, IN ULONG OutBufferSize, OUT OPTIONAL PULONG OutSize)
  GetSourceFileInformation	stdmethod(IDebugAdvanced2 *THIS, IN ULONG Which, IN PSTR SourceFile, IN ULONG64 Arg64, IN ULONG Arg32, OUT OPTIONAL PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG InfoSize)
  FindSourceFileAndToken	stdmethod(IDebugAdvanced2 *THIS, IN ULONG StartElement, IN ULONG64 ModAddr, IN PCSTR File, IN ULONG Flags, IN OPTIONAL PVOID FileToken, IN ULONG FileTokenSize, OUT OPTIONAL PULONG FoundElement, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG FoundSize)
  GetSymbolInformation		stdmethod(IDebugAdvanced2 *THIS, IN ULONG Which,  IN ULONG64 Arg64, IN ULONG Arg32, OUT OPTIONAL PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG InfoSize, OUT OPTIONAL PSTR StringBuffer, IN ULONG StringBufferSize, OUT OPTIONAL PULONG StringSize)
  GetSystemObjectInformation	stdmethod(IDebugAdvanced2 *THIS, IN ULONG Which,  IN ULONG64 Arg64, IN ULONG Arg32, OUT OPTIONAL PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG InfoSize)
endi

interface IDebugAdvanced3 extends IDebugAdvanced2
  GUID				CBA4ABB4-84C4-444D-87CA-A04E13286739
  GetSourceFileInformationWide	stdmethod(IDebugAdvanced3 *THIS, IN ULONG Which, IN PWSTR SourceFile, IN ULONG64 Arg64, IN ULONG Arg32, OUT OPTIONAL PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG InfoSize)
  FindSourceFileAndTokenWide	stdmethod(IDebugAdvanced3 *THIS, IN ULONG StartElement, IN ULONG64 ModAddr, IN PCWSTR File, IN ULONG Flags, IN OPTIONAL PVOID FileToken, IN ULONG FileTokenSize, OUT OPTIONAL PULONG FoundElement, OUT OPTIONAL PWSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG FoundSize)
  GetSymbolInformationWide	stdmethod(IDebugAdvanced3 *THIS, IN ULONG Which,  IN ULONG64 Arg64, IN ULONG Arg32, OUT OPTIONAL PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG InfoSize, OUT OPTIONAL PWSTR StringBuffer, IN ULONG StringBufferSize, OUT OPTIONAL PULONG StringSize)
endi

interface IDebugBreakpoint extends IUnknown
  GUID			5BD9D474-5975-423A-B88B-65A8E7110E65
  GetId 		stdmethod(IDebugBreakpoint *THIS, OUT PULONG Id)
  GetType		stdmethod(IDebugBreakpoint *THIS, OUT PULONG BreakType, OUT PULONG ProcType)
  GetAdder		stdmethod(IDebugBreakpoint *THIS, OUT PDEBUG_CLIENT* Adder)
  GetFlags		stdmethod(IDebugBreakpoint *THIS, OUT PULONG Flags)
  AddFlags		stdmethod(IDebugBreakpoint *THIS, IN ULONG Flags)
  RemoveFlags		stdmethod(IDebugBreakpoint *THIS, IN ULONG Flags)
  SetFlags		stdmethod(IDebugBreakpoint *THIS, IN ULONG Flags)
  GetOffset		stdmethod(IDebugBreakpoint *THIS, OUT PULONG64 Offset)
  SetOffset		stdmethod(IDebugBreakpoint *THIS, IN ULONG64 Offset)
  GetDataParameters	stdmethod(IDebugBreakpoint *THIS, OUT PULONG Size, OUT PULONG AccessType)
  SetDataParameters	stdmethod(IDebugBreakpoint *THIS, IN ULONG Size, IN ULONG AccessType)
  GetPassCount		stdmethod(IDebugBreakpoint *THIS, OUT PULONG Count)
  SetPassCount		stdmethod(IDebugBreakpoint *THIS, IN ULONG Count)
  GetCurrentPassCount	stdmethod(IDebugBreakpoint *THIS, OUT PULONG Count)
  GetMatchThreadId	stdmethod(IDebugBreakpoint *THIS, OUT PULONG Id)
  SetMatchThreadId	stdmethod(IDebugBreakpoint *THIS, IN ULONG Thread)
  GetCommand		stdmethod(IDebugBreakpoint *THIS, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG CommandSize)
  SetCommand		stdmethod(IDebugBreakpoint *THIS, IN PCSTR Command)
  GetOffsetExpression	stdmethod(IDebugBreakpoint *THIS, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG ExpressionSize)
  SetOffsetExpression	stdmethod(IDebugBreakpoint *THIS, IN PCSTR Expression)
  GetParameters 	stdmethod(IDebugBreakpoint *THIS, OUT PDEBUG_BREAKPOINT_PARAMETERS Params)
endi

interface IDebugBreakpoint2 extends IDebugBreakpoint
  GUID				1B278D20-79F2-426E-A3F9-C1DDF375D48E
  GetCommandWide		stdmethod(IDebugBreakpoint2 *THIS, OUT OPTIONAL PWSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG CommandSize)
  SetCommandWide		stdmethod(IDebugBreakpoint2 *THIS, IN PCWSTR Command)
  GetOffsetExpressionWide	stdmethod(IDebugBreakpoint2 *THIS, OUT OPTIONAL PWSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG ExpressionSize)
  SetOffsetExpressionWide	stdmethod(IDebugBreakpoint2 *THIS, IN PCWSTR Expression)
endi

interface IDebugBreakpoint3 extends IDebugBreakpoint2
  GUID		38F5C249-B448-43BB-9835-579D4EC02249
  GetGuid	stdmethod(IDebugBreakpoint3 *THIS, OUT LPGUID Guid)
endi

interface IDebugClient extends IUnknown
  GUID						27FE5639-8407-4F47-8364-EE118FB08AC8
  AttachKernel					stdmethod(IDebugClient *THIS, IN ULONG Flags, IN OPTIONAL PCSTR ConnectOptions)
  GetKernelConnectionOptions			stdmethod(IDebugClient *THIS, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG OptionsSize)
  SetKernelConnectionOptions			stdmethod(IDebugClient *THIS, IN PCSTR Options)
  StartProcessServer				stdmethod(IDebugClient *THIS, IN ULONG Flags, IN PCSTR Options, IN PVOID Reserved)
  ConnectProcessServer				stdmethod(IDebugClient *THIS, IN PCSTR RemoteOptions, OUT PULONG64 Server)
  DisconnectProcessServer			stdmethod(IDebugClient *THIS, IN ULONG64 Server)
  GetRunningProcessSystemIds			stdmethod(IDebugClient *THIS, IN ULONG64 Server, OUT OPTIONAL PULONG Ids, IN ULONG Count, OUT OPTIONAL PULONG ActualCount)
  GetRunningProcessSystemIdByExecutableName	stdmethod(IDebugClient *THIS, IN ULONG64 Server, IN PCSTR ExeName, IN ULONG Flags, OUT PULONG Id)
  GetRunningProcessDescription			stdmethod(IDebugClient *THIS, IN ULONG64 Server, IN ULONG SystemId, IN ULONG Flags, OUT OPTIONAL PSTR ExeName, IN ULONG ExeNameSize, OUT OPTIONAL PULONG ActualExeNameSize, OUT OPTIONAL PSTR Description, IN ULONG DescriptionSize, OUT OPTIONAL PULONG ActualDescriptionSize)
  AttachProcess 				stdmethod(IDebugClient *THIS, IN ULONG64 Server, IN ULONG ProcessId, IN ULONG AttachFlags)
  CreateProcess 				stdmethod(IDebugClient *THIS, IN ULONG64 Server, IN PSTR CommandLine, IN ULONG CreateFlags)
  CreateProcessAndAttach			stdmethod(IDebugClient *THIS, IN ULONG64 Server, IN OPTIONAL PSTR CommandLine, IN ULONG CreateFlags, IN ULONG ProcessId, IN ULONG AttachFlags)
  GetProcessOptions				stdmethod(IDebugClient *THIS, OUT PULONG Options)
  AddProcessOptions				stdmethod(IDebugClient *THIS, IN ULONG Options)
  RemoveProcessOptions				stdmethod(IDebugClient *THIS, IN ULONG Options)
  SetProcessOptions				stdmethod(IDebugClient *THIS, IN ULONG Options)
  OpenDumpFile					stdmethod(IDebugClient *THIS, IN PCSTR DumpFile)
  WriteDumpFile 				stdmethod(IDebugClient *THIS, IN PCSTR DumpFile, IN ULONG Qualifier)
  ConnectSession				stdmethod(IDebugClient *THIS, IN ULONG Flags, IN ULONG HistoryLimit)
  StartServer					stdmethod(IDebugClient *THIS, IN PCSTR Options)
  OutputServers 				stdmethod(IDebugClient *THIS, IN ULONG OutputControl, IN PCSTR Machine, IN ULONG Flags)
  TerminateProcesses				stdmethod(IDebugClient *THIS)
  DetachProcesses				stdmethod(IDebugClient *THIS)
  EndSession					stdmethod(IDebugClient *THIS, IN ULONG Flags)
  GetExitCode					stdmethod(IDebugClient *THIS, OUT PULONG Code)
  DispatchCallbacks				stdmethod(IDebugClient *THIS, IN ULONG Timeout)
  ExitDispatch					stdmethod(IDebugClient *THIS, IN PDEBUG_CLIENT Client)
  CreateClient					stdmethod(IDebugClient *THIS, OUT PDEBUG_CLIENT* Client)
  GetInputCallbacks				stdmethod(IDebugClient *THIS, OUT PDEBUG_INPUT_CALLBACKS* Callbacks)
  SetInputCallbacks				stdmethod(IDebugClient *THIS, IN PDEBUG_INPUT_CALLBACKS Callbacks)
  GetOutputCallbacks				stdmethod(IDebugClient *THIS, OUT PDEBUG_OUTPUT_CALLBACKS* Callbacks)
  SetOutputCallbacks				stdmethod(IDebugClient *THIS, IN PDEBUG_OUTPUT_CALLBACKS Callbacks)
  GetOutputMask 				stdmethod(IDebugClient *THIS, OUT PULONG Mask)
  SetOutputMask 				stdmethod(IDebugClient *THIS, IN ULONG Mask)
  GetOtherOutputMask				stdmethod(IDebugClient *THIS, IN PDEBUG_CLIENT Client, OUT PULONG Mask)
  SetOtherOutputMask				stdmethod(IDebugClient *THIS, IN PDEBUG_CLIENT Client, IN ULONG Mask)
  GetOutputWidth				stdmethod(IDebugClient *THIS, OUT PULONG Columns)
  SetOutputWidth				stdmethod(IDebugClient *THIS, IN ULONG Columns)
  GetOutputLinePrefix				stdmethod(IDebugClient *THIS, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG PrefixSize)
  SetOutputLinePrefix				stdmethod(IDebugClient *THIS, IN OPTIONAL PCSTR Prefix)
  GetIdentity					stdmethod(IDebugClient *THIS, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG IdentitySize)
  OutputIdentity				stdmethod(IDebugClient *THIS, IN ULONG OutputControl, IN ULONG Flags, IN PCSTR Format)
  GetEventCallbacks				stdmethod(IDebugClient *THIS, OUT PDEBUG_EVENT_CALLBACKS* Callbacks)
  SetEventCallbacks				stdmethod(IDebugClient *THIS, IN PDEBUG_EVENT_CALLBACKS Callbacks)
  FlushCallbacks				stdmethod(IDebugClient *THIS)
endi

interface IDebugClient2 extends IDebugClient
  GUID				EDBED635-372E-4DAB-BBFE-ED0D2F63BE81
  WriteDumpFile2		stdmethod(IDebugClient2 *THIS, IN PCSTR DumpFile, IN ULONG Qualifier, IN ULONG FormatFlags, IN OPTIONAL PCSTR Comment)
  AddDumpInformationFile	stdmethod(IDebugClient2 *THIS, IN PCSTR InfoFile, IN ULONG Type)
  EndProcessServer		stdmethod(IDebugClient2 *THIS, IN ULONG64 Server)
  WaitForProcessServerEnd	stdmethod(IDebugClient2 *THIS, IN ULONG Timeout)
  IsKernelDebuggerEnabled	stdmethod(IDebugClient2 *THIS)
  TerminateCurrentProcess	stdmethod(IDebugClient2 *THIS)
  DetachCurrentProcess		stdmethod(IDebugClient2 *THIS)
  AbandonCurrentProcess 	stdmethod(IDebugClient2 *THIS)
endi

interface IDebugClient3 extends IDebugClient2
  GUID						DD492D7F-71B8-4AD6-A8DC-1C887479FF91
  GetRunningProcessSystemIdByExecutableNameWide stdmethod(IDebugClient3 *THIS, IN ULONG64 Server, IN PCWSTR ExeName, IN ULONG Flags, OUT PULONG Id)
  GetRunningProcessDescriptionWide		stdmethod(IDebugClient3 *THIS, IN ULONG64 Server, IN ULONG SystemId, IN ULONG Flags, OUT OPTIONAL PWSTR ExeName, IN ULONG ExeNameSize, OUT OPTIONAL PULONG ActualExeNameSize, OUT OPTIONAL PWSTR Description, IN ULONG DescriptionSize, OUT OPTIONAL PULONG ActualDescriptionSize)
  CreateProcessWide				stdmethod(IDebugClient3 *THIS, IN ULONG64 Server, IN PWSTR CommandLine, IN ULONG CreateFlags)
  CreateProcessAndAttachWide			stdmethod(IDebugClient3 *THIS, IN ULONG64 Server, IN OPTIONAL PWSTR CommandLine, IN ULONG CreateFlags, IN ULONG ProcessId, IN ULONG AttachFlags)
endi

interface IDebugClient4 extends IDebugClient3
  GUID				CA83C3DE-5089-4CF8-93C8-D892387F2A5E
  OpenDumpFileWide		stdmethod(IDebugClient4 *THIS, IN OPTIONAL PCWSTR DumpFile, IN ULONG64 FileHandle)
  WriteDumpFileWide		stdmethod(IDebugClient4 *THIS, IN OPTIONAL PCWSTR DumpFile, IN ULONG64 FileHandle, IN ULONG Qualifier, IN ULONG FormatFlags, IN OPTIONAL PCWSTR Comment)
  AddDumpInformationFileWide	stdmethod(IDebugClient4 *THIS, IN OPTIONAL PCWSTR FileName, IN ULONG64 FileHandle, IN ULONG Type)
  GetNumberDumpFiles		stdmethod(IDebugClient4 *THIS, OUT PULONG Number)
  GetDumpFile			stdmethod(IDebugClient4 *THIS, IN ULONG Index, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG NameSize, OUT OPTIONAL PULONG64 Handle, OUT PULONG Type)
  GetDumpFileWide		stdmethod(IDebugClient4 *THIS, IN ULONG Index, OUT OPTIONAL PWSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG NameSize, OUT OPTIONAL PULONG64 Handle, OUT PULONG Type)
endi

interface IDebugClient5 extends IDebugClient4
  GUID					E3ACB9D7-7EC2-4F0C-A0DA-E81E0CBBE628
  AttachKernelWide			stdmethod(IDebugClient5 *THIS, )
  GetKernelConnectionOptionsWide	stdmethod(IDebugClient5 *THIS, )
  SetKernelConnectionOptionsWide	stdmethod(IDebugClient5 *THIS, )
  StartProcessServerWide		stdmethod(IDebugClient5 *THIS, )
  ConnectProcessServerWide		stdmethod(IDebugClient5 *THIS, )
  StartServerWide			stdmethod(IDebugClient5 *THIS, )
  OutputServersWide			stdmethod(IDebugClient5 *THIS, )
  GetOutputCallbacksWide		stdmethod(IDebugClient5 *THIS, )
  SetOutputCallbacksWide		stdmethod(IDebugClient5 *THIS, )
  GetOutputLinePrefixWide		stdmethod(IDebugClient5 *THIS, )
  SetOutputLinePrefixWide		stdmethod(IDebugClient5 *THIS, )
  GetIdentityWide			stdmethod(IDebugClient5 *THIS, )
  OutputIdentityWide			stdmethod(IDebugClient5 *THIS, )
  GetEventCallbacksWide 		stdmethod(IDebugClient5 *THIS, )
  SetEventCallbacksWide 		stdmethod(IDebugClient5 *THIS, )
  CreateProcess2			stdmethod(IDebugClient5 *THIS, )
  CreateProcess2Wide			stdmethod(IDebugClient5 *THIS, )
  CreateProcessAndAttach2		stdmethod(IDebugClient5 *THIS, )
  CreateProcessAndAttach2Wide		stdmethod(IDebugClient5 *THIS, )
  PushOutputLinePrefix			stdmethod(IDebugClient5 *THIS, )
  PushOutputLinePrefixWide		stdmethod(IDebugClient5 *THIS, )
  PopOutputLinePrefix			stdmethod(IDebugClient5 *THIS, )
  GetNumberInputCallbacks		stdmethod(IDebugClient5 *THIS, )
  GetNumberOutputCallbacks		stdmethod(IDebugClient5 *THIS, )
  GetNumberEventCallbacks		stdmethod(IDebugClient5 *THIS, )
  GetQuitLockString			stdmethod(IDebugClient5 *THIS, )
  SetQuitLockString			stdmethod(IDebugClient5 *THIS, )
  GetQuitLockStringWide 		stdmethod(IDebugClient5 *THIS, )
  SetQuitLockStringWide 		stdmethod(IDebugClient5 *THIS, )
endi

interface IDebugClient6 extends IDebugClient5
  GUID				FD28B4C5-C498-4686-A28E-62CAD2154EB3
  DUMMY 			stdmethod(IDebugClient6 *THIS)
endi

interface IDebugClient7 extends IDebugClient6
  GUID				13586BE3-542E-481E-B1F2-8497BA74F9A9
  DUMMY 			stdmethod(IDebugClient7 *THIS)
endi

interface IDebugControl extends IUnknown
  GUID						5182E668-105E-416E-AD92-24EF800424BA
  GetInterrupt					stdmethod(IDebugControl *THIS)
  SetInterrupt					stdmethod(IDebugControl *THIS, IN ULONG Flags)
  GetInterruptTimeout				stdmethod(IDebugControl *THIS, OUT PULONG Seconds)
  SetInterruptTimeout				stdmethod(IDebugControl *THIS, IN ULONG Seconds)
  GetLogFile					stdmethod(IDebugControl *THIS, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG FileSize, OUT PBOOL Append)
  OpenLogFile					stdmethod(IDebugControl *THIS, IN PCSTR File, IN BOOL Append)
  CloseLogFile					stdmethod(IDebugControl *THIS)
  GetLogMask					stdmethod(IDebugControl *THIS, OUT PULONG Mask)
  SetLogMask					stdmethod(IDebugControl *THIS, IN ULONG Mask)
  Input 					stdmethod(IDebugControl *THIS, OUT PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG InputSize)
  ReturnInput					stdmethod(IDebugControl *THIS, IN PCSTR Buffer)
  Output					stdmethod(IDebugControl *THIS, IN ULONG Mask, IN PCSTR Format, ...)
  OutputVaList					stdmethod(IDebugControl *THIS, IN ULONG Mask, IN PCSTR Format, IN va_list Args)
  ControlledOutput				stdmethod(IDebugControl *THIS, IN ULONG OutputControl, IN ULONG Mask, IN PCSTR Format, ...)
  ControlledOutputVaList			stdmethod(IDebugControl *THIS, IN ULONG OutputControl, IN ULONG Mask, IN PCSTR Format, IN va_list Args)
  OutputPrompt					stdmethod(IDebugControl *THIS, IN ULONG OutputControl, IN OPTIONAL PCSTR Format, ...)
  OutputPromptVaList				stdmethod(IDebugControl *THIS, IN ULONG OutputControl, IN OPTIONAL PCSTR Format, IN va_list Args)
  GetPromptText 				stdmethod(IDebugControl *THIS, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG TextSize)
  OutputCurrentState				stdmethod(IDebugControl *THIS, IN ULONG OutputControl, IN ULONG Flags)
  OutputVersionInformation			stdmethod(IDebugControl *THIS, IN ULONG OutputControl)
  GetNotifyEventHandle				stdmethod(IDebugControl *THIS, OUT PULONG64 Handle)
  SetNotifyEventHandle				stdmethod(IDebugControl *THIS, IN ULONG64 Handle)
  Assemble					stdmethod(IDebugControl *THIS, IN ULONG64 Offset, IN PCSTR Instr, OUT PULONG64 EndOffset)
  Disassemble					stdmethod(IDebugControl *THIS, IN ULONG64 Offset, IN ULONG Flags, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG DisassemblySize, OUT PULONG64 EndOffset)
  GetDisassembleEffectiveOffset 		stdmethod(IDebugControl *THIS, OUT PULONG64 Offset)
  OutputDisassembly				stdmethod(IDebugControl *THIS, IN ULONG OutputControl, IN ULONG64 Offset, IN ULONG Flags, OUT PULONG64 EndOffset)
  OutputDisassemblyLines			stdmethod(IDebugControl *THIS, IN ULONG OutputControl, IN ULONG PreviousLines, IN ULONG TotalLines, IN ULONG64 Offset, IN ULONG Flags, OUT OPTIONAL PULONG OffsetLine, OUT OPTIONAL PULONG64 StartOffset, OUT OPTIONAL PULONG64 EndOffset, OUT OPTIONAL PULONG64 LineOffsets)
  GetNearInstruction				stdmethod(IDebugControl *THIS, IN ULONG64 Offset, IN LONG Delta, OUT PULONG64 NearOffset)
  GetStackTrace 				stdmethod(IDebugControl *THIS, IN ULONG64 FrameOffset, IN ULONG64 StackOffset, IN ULONG64 InstructionOffset, OUT PDEBUG_STACK_FRAME Frames, IN ULONG FramesSize, OUT OPTIONAL PULONG FramesFilled)
  GetReturnOffset				stdmethod(IDebugControl *THIS, OUT PULONG64 Offset)
  OutputStackTrace				stdmethod(IDebugControl *THIS, IN ULONG OutputControl, IN OPTIONAL PDEBUG_STACK_FRAME Frames, IN ULONG FramesSize, IN ULONG Flags)
  GetDebuggeeType				stdmethod(IDebugControl *THIS, OUT PULONG Class, OUT PULONG Qualifier)
  GetActualProcessorType			stdmethod(IDebugControl *THIS, OUT PULONG Type)
  GetExecutingProcessorType			stdmethod(IDebugControl *THIS, OUT PULONG Type)
  GetNumberPossibleExecutingProcessorTypes	stdmethod(IDebugControl *THIS, OUT PULONG Number)
  GetPossibleExecutingProcessorTypes		stdmethod(IDebugControl *THIS, IN ULONG Start, IN ULONG Count, OUT PULONG Types)
  GetNumberProcessors				stdmethod(IDebugControl *THIS, OUT PULONG Number)
  GetSystemVersion				stdmethod(IDebugControl *THIS, OUT PULONG PlatformId, OUT PULONG Major, OUT PULONG Minor, OUT OPTIONAL PSTR ServicePackString, IN ULONG ServicePackStringSize, OUT OPTIONAL PULONG ServicePackStringUsed, OUT PULONG ServicePackNumber, OUT OPTIONAL PSTR BuildString, IN ULONG BuildStringSize, OUT OPTIONAL PULONG BuildStringUsed)
  GetPageSize					stdmethod(IDebugControl *THIS, OUT PULONG Size)
  IsPointer64Bit				stdmethod(IDebugControl *THIS)
  ReadBugCheckData				stdmethod(IDebugControl *THIS, OUT PULONG Code, OUT PULONG64 Arg1, OUT PULONG64 Arg2, OUT PULONG64 Arg3, OUT PULONG64 Arg4)
  GetNumberSupportedProcessorTypes		stdmethod(IDebugControl *THIS, OUT PULONG Number)
  GetSupportedProcessorTypes			stdmethod(IDebugControl *THIS, IN ULONG Start, IN ULONG Count, OUT PULONG Types)
  GetProcessorTypeNames 			stdmethod(IDebugControl *THIS, IN ULONG Type, OUT OPTIONAL PSTR FullNameBuffer, IN ULONG FullNameBufferSize, OUT OPTIONAL PULONG FullNameSize, OUT OPTIONAL PSTR AbbrevNameBuffer, IN ULONG AbbrevNameBufferSize, OUT OPTIONAL PULONG AbbrevNameSize)
  GetEffectiveProcessorType			stdmethod(IDebugControl *THIS, OUT PULONG Type)
  SetEffectiveProcessorType			stdmethod(IDebugControl *THIS, IN ULONG Type)
  GetExecutionStatus				stdmethod(IDebugControl *THIS, OUT PULONG Status)
  SetExecutionStatus				stdmethod(IDebugControl *THIS, IN ULONG Status)
  GetCodeLevel					stdmethod(IDebugControl *THIS, OUT PULONG Level)
  SetCodeLevel					stdmethod(IDebugControl *THIS, IN ULONG Level)
  GetEngineOptions				stdmethod(IDebugControl *THIS, OUT PULONG Options)
  AddEngineOptions				stdmethod(IDebugControl *THIS, IN ULONG Options)
  RemoveEngineOptions				stdmethod(IDebugControl *THIS, IN ULONG Options)
  SetEngineOptions				stdmethod(IDebugControl *THIS, IN ULONG Options)
  GetSystemErrorControl 			stdmethod(IDebugControl *THIS, OUT PULONG OutputLevel, OUT PULONG BreakLevel)
  SetSystemErrorControl 			stdmethod(IDebugControl *THIS, IN ULONG OutputLevel, IN ULONG BreakLevel)
  GetTextMacro					stdmethod(IDebugControl *THIS, IN ULONG Slot, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG MacroSize)
  SetTextMacro					stdmethod(IDebugControl *THIS, IN ULONG Slot, IN PCSTR Macro)
  GetRadix					stdmethod(IDebugControl *THIS, OUT PULONG Radix)
  SetRadix					stdmethod(IDebugControl *THIS, IN ULONG Radix)
  Evaluate					stdmethod(IDebugControl *THIS, IN PCSTR Expression, IN ULONG DesiredType, OUT PDEBUG_VALUE Value, OUT OPTIONAL PULONG RemainderIndex)
  CoerceValue					stdmethod(IDebugControl *THIS, IN PDEBUG_VALUE In, IN ULONG OutType, OUT PDEBUG_VALUE Out)
  CoerceValues					stdmethod(IDebugControl *THIS, IN ULONG Count, IN PDEBUG_VALUE In, IN PULONG OutTypes, OUT PDEBUG_VALUE Out)
  Execute					stdmethod(IDebugControl *THIS, IN ULONG OutputControl, IN PCSTR Command, IN ULONG Flags)
  ExecuteCommandFile				stdmethod(IDebugControl *THIS, IN ULONG OutputControl, IN PCSTR CommandFile, IN ULONG Flags)
  GetNumberBreakpoints				stdmethod(IDebugControl *THIS, OUT PULONG Number)
  GetBreakpointByIndex				stdmethod(IDebugControl *THIS, IN ULONG Index, OUT PDEBUG_BREAKPOINT* Bp)
  GetBreakpointById				stdmethod(IDebugControl *THIS, IN ULONG Id, OUT PDEBUG_BREAKPOINT* Bp)
  GetBreakpointParameters			stdmethod(IDebugControl *THIS, IN ULONG Count, IN OPTIONAL PULONG Ids, IN ULONG Start, OUT PDEBUG_BREAKPOINT_PARAMETERS Params)
  AddBreakpoint 				stdmethod(IDebugControl *THIS, IN ULONG Type, IN ULONG DesiredId, OUT PDEBUG_BREAKPOINT* Bp)
  RemoveBreakpoint				stdmethod(IDebugControl *THIS, IN PDEBUG_BREAKPOINT Bp)
  AddExtension					stdmethod(IDebugControl *THIS, IN PCSTR Path, IN ULONG Flags, OUT PULONG64 Handle)
  RemoveExtension				stdmethod(IDebugControl *THIS, IN ULONG64 Handle)
  GetExtensionByPath				stdmethod(IDebugControl *THIS, IN PCSTR Path, OUT PULONG64 Handle)
  CallExtension 				stdmethod(IDebugControl *THIS, IN ULONG64 Handle, IN PCSTR Function, IN OPTIONAL PCSTR Arguments)
  GetExtensionFunction				stdmethod(IDebugControl *THIS, IN ULONG64 Handle, IN PCSTR FuncName, OUT FARPROC* Function)
  GetWindbgExtensionApis32			stdmethod(IDebugControl *THIS, IN OUT PWINDBG_EXTENSION_APIS32 Api)
  GetWindbgExtensionApis64			stdmethod(IDebugControl *THIS, IN OUT PWINDBG_EXTENSION_APIS64 Api)
  GetNumberEventFilters 			stdmethod(IDebugControl *THIS, OUT PULONG SpecificEvents, OUT PULONG SpecificExceptions, OUT PULONG ArbitraryExceptions)
  GetEventFilterText				stdmethod(IDebugControl *THIS, IN ULONG Index, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG TextSize)
  GetEventFilterCommand 			stdmethod(IDebugControl *THIS, IN ULONG Index, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG CommandSize)
  SetEventFilterCommand 			stdmethod(IDebugControl *THIS, IN ULONG Index, IN PCSTR Command)
  GetSpecificFilterParameters			stdmethod(IDebugControl *THIS, IN ULONG Start, IN ULONG Count, OUT PDEBUG_SPECIFIC_FILTER_PARAMETERS Params)
  SetSpecificFilterParameters			stdmethod(IDebugControl *THIS, IN ULONG Start, IN ULONG Count, IN PDEBUG_SPECIFIC_FILTER_PARAMETERS Params)
  GetSpecificFilterArgument			stdmethod(IDebugControl *THIS, IN ULONG Index, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG ArgumentSize)
  SetSpecificFilterArgument			stdmethod(IDebugControl *THIS, IN ULONG Index, IN PCSTR Argument)
  GetExceptionFilterParameters			stdmethod(IDebugControl *THIS, IN ULONG Count, IN OPTIONAL PULONG Codes, IN ULONG Start, OUT PDEBUG_EXCEPTION_FILTER_PARAMETERS Params)
  SetExceptionFilterParameters			stdmethod(IDebugControl *THIS, IN ULONG Count, IN PDEBUG_EXCEPTION_FILTER_PARAMETERS Params)
  GetExceptionFilterSecondCommand		stdmethod(IDebugControl *THIS, IN ULONG Index, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG CommandSize)
  SetExceptionFilterSecondCommand		stdmethod(IDebugControl *THIS, IN ULONG Index, IN PCSTR Command)
  WaitForEvent					stdmethod(IDebugControl *THIS, IN ULONG Flags, IN ULONG Timeout)
  GetLastEventInformation			stdmethod(IDebugControl *THIS, OUT PULONG Type, OUT PULONG ProcessId, OUT PULONG ThreadId, OUT OPTIONAL PVOID ExtraInformation, IN ULONG ExtraInformationSize, OUT OPTIONAL PULONG ExtraInformationUsed, OUT OPTIONAL PSTR Description, IN ULONG DescriptionSize, OUT OPTIONAL PULONG DescriptionUsed)
endi

interface IDebugControl2 extends IDebugControl
  GUID				D4366723-44DF-4BED-8C7E-4C05424F4588
  GetCurrentTimeDate		stdmethod(IDebugControl2 *THIS, OUT PULONG TimeDate)
  GetCurrentSystemUpTime	stdmethod(IDebugControl2 *THIS, OUT PULONG UpTime)
  GetDumpFormatFlags		stdmethod(IDebugControl2 *THIS, OUT PULONG FormatFlags)
  GetNumberTextReplacements	stdmethod(IDebugControl2 *THIS, OUT PULONG NumRepl)
  GetTextReplacement		stdmethod(IDebugControl2 *THIS, IN OPTIONAL PCSTR SrcText, IN ULONG Index, OUT OPTIONAL PSTR SrcBuffer, IN ULONG SrcBufferSize, OUT OPTIONAL PULONG SrcSize, OUT OPTIONAL PSTR DstBuffer, IN ULONG DstBufferSize, OUT OPTIONAL PULONG DstSize)
  SetTextReplacement		stdmethod(IDebugControl2 *THIS, IN PCSTR SrcText, IN OPTIONAL PCSTR DstText)
  RemoveTextReplacements	stdmethod(IDebugControl2 *THIS)
  OutputTextReplacements	stdmethod(IDebugControl2 *THIS, IN ULONG OutputControl, IN ULONG Flags)
endi

interface IDebugControl3 extends IDebugControl2
  GUID				7DF74A86-B03F-407F-90AB-A20DADCEAD08
  DUMMY 			stdmethod(IDebugControl3 *THIS, )
endi

interface IDebugControl4 extends IDebugControl3
  GUID				94E60CE9-9B41-4B19-9FC0-6D9EB35272B3
  DUMMY 			stdmethod(IDebugControl4 *THIS, )
endi

interface IDebugControl5 extends IDebugControl4
  GUID				B2FFE162-2412-429F-8D1D-5BF6DD824696
  DUMMY 			stdmethod(IDebugControl5 *THIS, )
endi

interface IDebugControl6 extends IDebugControl5
  GUID				BC0D583F-126D-43A1-9CC4-A860AB1D537B
  DUMMY 			stdmethod(IDebugControl6 *THIS, )
endi

interface IDebugControl7 extends IDebugControl6
  GUID				B86FB3B1-80D4-475B-AEA3-CF06539CF63A
  DUMMY 			stdmethod(IDebugControl7 *THIS, )
endi

interface IDebugDataSpaces extends IUnknown
  GUID				88F7DFAB-3EA7-4C3A-AEFB-C4E8106173AA
  ReadVirtual			stdmethod(IDebugDataSpaces *THIS, IN ULONG64 Offset, OUT PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG BytesRead)
  WriteVirtual			stdmethod(IDebugDataSpaces *THIS, IN ULONG64 Offset, IN PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG BytesWritten)
  SearchVirtual 		stdmethod(IDebugDataSpaces *THIS, IN ULONG64 Offset, IN ULONG64 Length, IN PVOID Pattern, IN ULONG PatternSize, IN ULONG PatternGranularity, OUT PULONG64 MatchOffset)
  ReadVirtualUncached		stdmethod(IDebugDataSpaces *THIS, IN ULONG64 Offset, OUT PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG BytesRead)
  WriteVirtualUncached		stdmethod(IDebugDataSpaces *THIS, IN ULONG64 Offset, IN PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG BytesWritten)
  ReadPointersVirtual		stdmethod(IDebugDataSpaces *THIS, IN ULONG Count, IN ULONG64 Offset, OUT PULONG64 Ptrs)
  WritePointersVirtual		stdmethod(IDebugDataSpaces *THIS, IN ULONG Count, IN ULONG64 Offset, IN PULONG64 Ptrs)
  ReadPhysical			stdmethod(IDebugDataSpaces *THIS, IN ULONG64 Offset, OUT PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG BytesRead)
  WritePhysical 		stdmethod(IDebugDataSpaces *THIS, IN ULONG64 Offset, IN PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG BytesWritten)
  ReadControl			stdmethod(IDebugDataSpaces *THIS, IN ULONG Processor, IN ULONG64 Offset, OUT PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG BytesRead)
  WriteControl			stdmethod(IDebugDataSpaces *THIS, IN ULONG Processor, IN ULONG64 Offset, IN PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG BytesWritten)
  ReadIo			stdmethod(IDebugDataSpaces *THIS, IN ULONG InterfaceType, IN ULONG BusNumber, IN ULONG AddressSpace, IN ULONG64 Offset, OUT PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG BytesRead)
  WriteIo			stdmethod(IDebugDataSpaces *THIS, IN ULONG InterfaceType, IN ULONG BusNumber, IN ULONG AddressSpace, IN ULONG64 Offset, IN PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG BytesWritten)
  ReadMsr			stdmethod(IDebugDataSpaces *THIS, IN ULONG Msr, OUT PULONG64 Value)
  WriteMsr			stdmethod(IDebugDataSpaces *THIS, IN ULONG Msr, IN ULONG64 Value)
  ReadBusData			stdmethod(IDebugDataSpaces *THIS, IN ULONG BusDataType, IN ULONG BusNumber, IN ULONG SlotNumber, IN ULONG Offset, OUT PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG BytesRead)
  WriteBusData			stdmethod(IDebugDataSpaces *THIS, IN ULONG BusDataType, IN ULONG BusNumber, IN ULONG SlotNumber, IN ULONG Offset, IN PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG BytesWritten)
  CheckLowMemory		stdmethod(IDebugDataSpaces *THIS)
  ReadDebuggerData		stdmethod(IDebugDataSpaces *THIS, IN ULONG Index, OUT PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG DataSize)
  ReadProcessorSystemData	stdmethod(IDebugDataSpaces *THIS, IN ULONG Processor, IN ULONG Index, OUT PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG DataSize)
endi

interface IDebugDataSpaces2 extends IDebugDataSpaces
  GUID					7A5E852F-96E9-468F-AC1B-0b3ADDC4A049
  VirtualToPhysical			stdmethod(IDebugDataSpaces2 *THIS, IN ULONG64 Virtual, OUT PULONG64 Physical)
  GetVirtualTranslationPhysicalOffsets	stdmethod(IDebugDataSpaces2 *THIS, IN ULONG64 Virtual, OUT OPTIONAL PULONG64 Offsets, IN ULONG OffsetsSize, OUT OPTIONAL PULONG Levels)
  ReadHandleData			stdmethod(IDebugDataSpaces2 *THIS, IN ULONG64 Handle, IN ULONG DataType, OUT OPTIONAL PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG DataSize)
  FillVirtual				stdmethod(IDebugDataSpaces2 *THIS, IN ULONG64 Start, IN ULONG Size, IN PVOID Pattern, IN ULONG PatternSize, OUT OPTIONAL PULONG Filled)
  FillPhysical				stdmethod(IDebugDataSpaces2 *THIS, IN ULONG64 Start, IN ULONG Size, IN PVOID Pattern, IN ULONG PatternSize, OUT OPTIONAL PULONG Filled)
  QueryVirtual				stdmethod(IDebugDataSpaces2 *THIS, IN ULONG64 Offset, OUT PMEMORY_BASIC_INFORMATION64 Info)
endi

interface IDebugDataSpaces3 extends IDebugDataSpaces2
  GUID					23F79D6C-8AAF-4F7C-A607-9995F5407E63
  DUMMY 				stdmethod(IDebugDataSpaces3 *THIS, )
endi

interface IDebugDataSpaces4 extends IDebugDataSpaces3
  GUID					D98ADA1F-29E9-4EF5-A6C0-E53349883212
  DUMMY 				stdmethod(IDebugDataSpaces4 *THIS, )
endi

interface IDebugEventCallbacks extends IUnknown
  GUID			337BE28B-5036-4D72-B6BF-C45FBB9F2EAA
  GetInterestMask	stdmethod(IDebugEventCallbacks *THIS, OUT PULONG Mask)
  Breakpoint		stdmethod(IDebugEventCallbacks *THIS, IN PDEBUG_BREAKPOINT Bp)
  Exception		stdmethod(IDebugEventCallbacks *THIS, IN PEXCEPTION_RECORD64 Exception, IN ULONG FirstChance)
  CreateThread		stdmethod(IDebugEventCallbacks *THIS, IN ULONG64 Handle, IN ULONG64 DataOffset, IN ULONG64 StartOffset)
  ExitThread		stdmethod(IDebugEventCallbacks *THIS, IN ULONG ExitCode)
  CreateProcess 	stdmethod(IDebugEventCallbacks *THIS, IN ULONG64 ImageFileHandle, IN ULONG64 Handle, IN ULONG64 BaseOffset, IN ULONG ModuleSize, IN PCSTR ModuleName, IN PCSTR ImageName, IN ULONG CheckSum, IN ULONG TimeDateStamp, IN ULONG64 InitialThreadHandle, IN ULONG64 ThreadDataOffset, IN ULONG64 StartOffset)
  ExitProcess		stdmethod(IDebugEventCallbacks *THIS, IN ULONG ExitCode)
  LoadModule		stdmethod(IDebugEventCallbacks *THIS, IN ULONG64 ImageFileHandle, IN ULONG64 BaseOffset, IN ULONG ModuleSize, IN PCSTR ModuleName, IN PCSTR ImageName, IN ULONG CheckSum, IN ULONG TimeDateStamp)
  UnloadModule		stdmethod(IDebugEventCallbacks *THIS, IN PCSTR ImageBaseName, IN ULONG64 BaseOffset)
  SystemError		stdmethod(IDebugEventCallbacks *THIS, IN ULONG Error, IN ULONG Level)
  SessionStatus 	stdmethod(IDebugEventCallbacks *THIS, IN ULONG Status)
  ChangeDebuggeeState	stdmethod(IDebugEventCallbacks *THIS, IN ULONG Flags, IN ULONG64 Argument)
  ChangeEngineState	stdmethod(IDebugEventCallbacks *THIS, IN ULONG Flags, IN ULONG64 Argument)
  ChangeSymbolState	stdmethod(IDebugEventCallbacks *THIS, IN ULONG Flags, IN ULONG64 Argument)
endi

interface IDebugEventCallbacksWide extends IUnknown
  GUID			0690E046-9C23-45AC-A04F-987AC29AD0D3
  DUMMY 		stdmethod(IDebugEventCallbacksWide *THIS, )
endi

interface IDebugEventContextCallbacks extends IUnknown
  GUID			61A4905B-23F9-4247-B3C5-53D087529AB7
  DUMMY 		stdmethod(IDebugEventContextCallbacks *THIS, )
endi

interface IDebugInputCallbacks extends IUnknown
  GUID			9F50E42C-F136-499E-9A97-73036C94ED2D
  StartInput		stdmethod(IDebugInputCallbacks *THIS, IN ULONG BufferSize)
  EndInput		stdmethod(IDebugInputCallbacks *THIS)
endi

interface IDebugOutputCallbacks extends IUnknown
  GUID			4BF58045-D654-4C40-B0AF-683090F356DC
  Output		stdmethod(IDebugOutputCallbacks *THIS, IN ULONG Mask, IN PCSTR Text)
endi

interface IDebugOutputCallbacksWide extends IUnknown
  GUID			4C7FD663-C394-4E26-8EF1-34AD5ED3764C
  DUMMY 		stdmethod(IDebugOutputCallbacksWide *THIS, )
endi

interface IDebugOutputCallbacks2 extends IDebugOutputCallbacks
  GUID			67721FE9-56D2-4A44-A325-2B65513CE6EB
  DUMMY 		stdmethod(IDebugOutputCallbacks2 *THIS, )
endi

interface IDebugRegisters extends IUnknown
  GUID			CE289126-9E84-45A7-937E-67BB18691493
  GetNumberRegisters	stdmethod(IDebugRegisters *THIS, OUT PULONG Number)
  GetDescription	stdmethod(IDebugRegisters *THIS, IN ULONG Register, OUT OPTIONAL PSTR NameBuffer, IN ULONG NameBufferSize, OUT OPTIONAL PULONG NameSize, OUT OPTIONAL PDEBUG_REGISTER_DESCRIPTION Desc)
  GetIndexByName	stdmethod(IDebugRegisters *THIS, IN PCSTR Name, OUT PULONG Index)
  GetValue		stdmethod(IDebugRegisters *THIS, IN ULONG Register, OUT PDEBUG_VALUE Value)
  SetValue		stdmethod(IDebugRegisters *THIS, IN ULONG Register, IN PDEBUG_VALUE Value)
  GetValues		stdmethod(IDebugRegisters *THIS, IN ULONG Count, IN OPTIONAL PULONG Indices, IN ULONG Start, OUT PDEBUG_VALUE Values)
  SetValues		stdmethod(IDebugRegisters *THIS, IN ULONG Count, IN OPTIONAL PULONG Indices, IN ULONG Start, IN PDEBUG_VALUE Values)
  OutputRegisters	stdmethod(IDebugRegisters *THIS, IN ULONG OutputControl, IN ULONG Flags)
  GetInstructionOffset	stdmethod(IDebugRegisters *THIS, OUT PULONG64 Offset)
  GetStackOffset	stdmethod(IDebugRegisters *THIS, OUT PULONG64 Offset)
  GetFrameOffset	stdmethod(IDebugRegisters *THIS, OUT PULONG64 Offset)
endi

interface IDebugRegisters2 extends IDebugRegisters
  GUID			1656AFA9-19C6-4E3A-97E7-5DC9160CF9C4
  DUMMY 		stdmethod(IDebugRegisters2 *THIS, )
endi

interface IDebugSymbolGroup extends IUnknown
  GUID			F2528316-0F1A-4431-AEED-11D096E1E2AB
  GetNumberSymbols	stdmethod(IDebugSymbolGroup *THIS, OUT PULONG Number)
  AddSymbol		stdmethod(IDebugSymbolGroup *THIS, IN PCSTR Name, OUT PULONG Index)
  RemoveSymbolByName	stdmethod(IDebugSymbolGroup *THIS, IN PCSTR Name)
  RemoveSymbolByIndex	stdmethod(IDebugSymbolGroup *THIS, IN ULONG Index)
  GetSymbolName 	stdmethod(IDebugSymbolGroup *THIS, IN ULONG Index, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG NameSize)
  GetSymbolParameters	stdmethod(IDebugSymbolGroup *THIS, IN ULONG Start, IN ULONG Count, OUT PDEBUG_SYMBOL_PARAMETERS Params)
  ExpandSymbol		stdmethod(IDebugSymbolGroup *THIS, IN ULONG Index, IN BOOL Expand)
  OutputSymbols 	stdmethod(IDebugSymbolGroup *THIS, IN ULONG OutputControl, IN ULONG Flags, IN ULONG Start, IN ULONG Count)
  WriteSymbol		stdmethod(IDebugSymbolGroup *THIS, IN ULONG Index, IN PCSTR Value)
  OutputAsType		stdmethod(IDebugSymbolGroup *THIS, IN ULONG Index, IN PCSTR Type)
endi

interface IDebugSymbolGroup2 extends IDebugSymbolGroup
  GUID			6A7CCC5F-FB5E-4DCC-B41C-6C20307BCCC7
  DUMMY 		stdmethod(IDebugSymbolGroup2 *THIS, )
endi

interface IDebugSymbols extends IUnknown
  GUID				8C31E98C-983A-48A5-9016-6FE5D667A950
  GetSymbolOptions		stdmethod(IDebugSymbols *THIS, OUT PULONG Options)
  AddSymbolOptions		stdmethod(IDebugSymbols *THIS, IN ULONG Options)
  RemoveSymbolOptions		stdmethod(IDebugSymbols *THIS, IN ULONG Options)
  SetSymbolOptions		stdmethod(IDebugSymbols *THIS, IN ULONG Options)
  GetNameByOffset		stdmethod(IDebugSymbols *THIS, IN ULONG64 Offset, OUT OPTIONAL PSTR NameBuffer, IN ULONG NameBufferSize, OUT OPTIONAL PULONG NameSize, OUT OPTIONAL PULONG64 Displacement)
  GetOffsetByName		stdmethod(IDebugSymbols *THIS, IN PCSTR Symbol, OUT PULONG64 Offset)
  GetNearNameByOffset		stdmethod(IDebugSymbols *THIS, IN ULONG64 Offset, IN LONG Delta, OUT OPTIONAL PSTR NameBuffer, IN ULONG NameBufferSize, OUT OPTIONAL PULONG NameSize, OUT OPTIONAL PULONG64 Displacement)
  GetLineByOffset		stdmethod(IDebugSymbols *THIS, IN ULONG64 Offset, OUT OPTIONAL PULONG Line, OUT OPTIONAL PSTR FileBuffer, IN ULONG FileBufferSize, OUT OPTIONAL PULONG FileSize, OUT OPTIONAL PULONG64 Displacement)
  GetOffsetByLine		stdmethod(IDebugSymbols *THIS, IN ULONG Line, IN PCSTR File, OUT PULONG64 Offset)
  GetNumberModules		stdmethod(IDebugSymbols *THIS, OUT PULONG Loaded, OUT PULONG Unloaded)
  GetModuleByIndex		stdmethod(IDebugSymbols *THIS, IN ULONG Index, OUT PULONG64 Base)
  GetModuleByModuleName 	stdmethod(IDebugSymbols *THIS, IN PCSTR Name, IN ULONG StartIndex, OUT OPTIONAL PULONG Index, OUT OPTIONAL PULONG64 Base)
  GetModuleByOffset		stdmethod(IDebugSymbols *THIS, IN ULONG64 Offset, IN ULONG StartIndex, OUT OPTIONAL PULONG Index, OUT OPTIONAL PULONG64 Base)
  GetModuleNames		stdmethod(IDebugSymbols *THIS, IN ULONG Index, IN ULONG64 Base, OUT OPTIONAL PSTR ImageNameBuffer, IN ULONG ImageNameBufferSize, OUT OPTIONAL PULONG ImageNameSize, OUT OPTIONAL PSTR ModuleNameBuffer, IN ULONG ModuleNameBufferSize, OUT OPTIONAL PULONG ModuleNameSize, OUT OPTIONAL PSTR LoadedImageNameBuffer, IN ULONG LoadedImageNameBufferSize, OUT OPTIONAL PULONG LoadedImageNameSize)
  GetModuleParameters		stdmethod(IDebugSymbols *THIS, IN ULONG Count, IN OPTIONAL PULONG64 Bases, IN ULONG Start, OUT PDEBUG_MODULE_PARAMETERS Params)
  GetSymbolModule		stdmethod(IDebugSymbols *THIS, IN PCSTR Symbol, OUT PULONG64 Base)
  GetTypeName			stdmethod(IDebugSymbols *THIS, IN ULONG64 Module, IN ULONG TypeId, OUT OPTIONAL PSTR NameBuffer, IN ULONG NameBufferSize, OUT OPTIONAL PULONG NameSize)
  GetTypeId			stdmethod(IDebugSymbols *THIS, IN ULONG64 Module, IN PCSTR Name, OUT PULONG TypeId)
  GetTypeSize			stdmethod(IDebugSymbols *THIS, IN ULONG64 Module, IN ULONG TypeId, OUT PULONG Size)
  GetFieldOffset		stdmethod(IDebugSymbols *THIS, IN ULONG64 Module, IN ULONG TypeId, IN PCSTR Field, OUT PULONG Offset)
  GetSymbolTypeId		stdmethod(IDebugSymbols *THIS, IN PCSTR Symbol, OUT PULONG TypeId, OUT OPTIONAL PULONG64 Module)
  GetOffsetTypeId		stdmethod(IDebugSymbols *THIS, IN ULONG64 Offset, OUT PULONG TypeId, OUT OPTIONAL PULONG64 Module)
  ReadTypedDataVirtual		stdmethod(IDebugSymbols *THIS, IN ULONG64 Offset, IN ULONG64 Module, IN ULONG TypeId, OUT PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG BytesRead)
  WriteTypedDataVirtual 	stdmethod(IDebugSymbols *THIS, IN ULONG64 Offset, IN ULONG64 Module, IN ULONG TypeId, IN PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG BytesWritten)
  OutputTypedDataVirtual	stdmethod(IDebugSymbols *THIS, IN ULONG OutputControl, IN ULONG64 Offset, IN ULONG64 Module, IN ULONG TypeId, IN ULONG Flags)
  ReadTypedDataPhysical 	stdmethod(IDebugSymbols *THIS, IN ULONG64 Offset, IN ULONG64 Module, IN ULONG TypeId, OUT PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG BytesRead)
  WriteTypedDataPhysical	stdmethod(IDebugSymbols *THIS, IN ULONG64 Offset, IN ULONG64 Module, IN ULONG TypeId, IN PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG BytesWritten)
  OutputTypedDataPhysical	stdmethod(IDebugSymbols *THIS, IN ULONG OutputControl, IN ULONG64 Offset, IN ULONG64 Module, IN ULONG TypeId, IN ULONG Flags)
  GetScope			stdmethod(IDebugSymbols *THIS, OUT OPTIONAL PULONG64 InstructionOffset, OUT OPTIONAL PDEBUG_STACK_FRAME ScopeFrame, OUT OPTIONAL PVOID ScopeContext, IN ULONG ScopeContextSize)
  SetScope			stdmethod(IDebugSymbols *THIS, IN ULONG64 InstructionOffset, IN OPTIONAL PDEBUG_STACK_FRAME ScopeFrame, IN OPTIONAL PVOID ScopeContext, IN ULONG ScopeContextSize)
  ResetScope			stdmethod(IDebugSymbols *THIS)
  GetScopeSymbolGroup		stdmethod(IDebugSymbols *THIS, IN ULONG Flags, IN OPTIONAL PDEBUG_SYMBOL_GROUP Update, OUT PDEBUG_SYMBOL_GROUP* Symbols)
  CreateSymbolGroup		stdmethod(IDebugSymbols *THIS, OUT PDEBUG_SYMBOL_GROUP* Group)
  StartSymbolMatch		stdmethod(IDebugSymbols *THIS, IN PCSTR Pattern, OUT PULONG64 Handle)
  GetNextSymbolMatch		stdmethod(IDebugSymbols *THIS, IN ULONG64 Handle, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG MatchSize, OUT OPTIONAL PULONG64 Offset)
  EndSymbolMatch		stdmethod(IDebugSymbols *THIS, IN ULONG64 Handle)
  Reload			stdmethod(IDebugSymbols *THIS, IN PCSTR Module)
  GetSymbolPath 		stdmethod(IDebugSymbols *THIS, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG PathSize)
  SetSymbolPath 		stdmethod(IDebugSymbols *THIS, IN PCSTR Path)
  AppendSymbolPath		stdmethod(IDebugSymbols *THIS, IN PCSTR Addition)
  GetImagePath			stdmethod(IDebugSymbols *THIS, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG PathSize)
  SetImagePath			stdmethod(IDebugSymbols *THIS, IN PCSTR Path)
  AppendImagePath		stdmethod(IDebugSymbols *THIS, IN PCSTR Addition)
  GetSourcePath 		stdmethod(IDebugSymbols *THIS, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG PathSize)
  GetSourcePathElement		stdmethod(IDebugSymbols *THIS, IN ULONG Index, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG ElementSize)
  SetSourcePath 		stdmethod(IDebugSymbols *THIS, IN PCSTR Path)
  AppendSourcePath		stdmethod(IDebugSymbols *THIS, IN PCSTR Addition)
  FindSourceFile		stdmethod(IDebugSymbols *THIS, IN ULONG StartElement, IN PCSTR File, IN ULONG Flags, OUT OPTIONAL PULONG FoundElement, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG FoundSize)
  GetSourceFileLineOffsets	stdmethod(IDebugSymbols *THIS, IN PCSTR File, OUT OPTIONAL PULONG64 Buffer, IN ULONG BufferLines, OUT OPTIONAL PULONG FileLines)
endi

interface IDebugSymbols2 extends IDebugSymbols
  GUID				3A707211-AFDD-4495-AD4F-56FECDF8163F
  GetModuleVersionInformation	stdmethod(IDebugSymbols2 *THIS, IN ULONG Index, IN ULONG64 Base, IN PCSTR Item, OUT OPTIONAL PVOID Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG VerInfoSize)
  GetModuleNameString		stdmethod(IDebugSymbols2 *THIS, IN ULONG Which, IN ULONG Index, IN ULONG64 Base, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG NameSize)
  GetConstantName		stdmethod(IDebugSymbols2 *THIS, IN ULONG64 Module, IN ULONG TypeId, IN ULONG64 Value, OUT OPTIONAL PSTR NameBuffer, IN ULONG NameBufferSize, OUT OPTIONAL PULONG NameSize)
  GetFieldName			stdmethod(IDebugSymbols2 *THIS, IN ULONG64 Module, IN ULONG TypeId, IN ULONG FieldIndex, OUT OPTIONAL PSTR NameBuffer, IN ULONG NameBufferSize, OUT OPTIONAL PULONG NameSize)
  GetTypeOptions		stdmethod(IDebugSymbols2 *THIS, OUT PULONG Options)
  AddTypeOptions		stdmethod(IDebugSymbols2 *THIS, IN ULONG Options)
  RemoveTypeOptions		stdmethod(IDebugSymbols2 *THIS, IN ULONG Options)
  SetTypeOptions		stdmethod(IDebugSymbols2 *THIS, IN ULONG Options)
endi

interface IDebugSymbols3 extends IDebugSymbols2
  GUID				F02FBECC-50AC-4F36-9AD9-C975E8F32FF8
  dUMMY 			stdmethod(IDebugSymbols3 *THIS, )
endi

interface IDebugSymbols4 extends IDebugSymbols3
  GUID				E391BBD8-9D8C-4418-840B-C006592A1752
  dUMMY 			stdmethod(IDebugSymbols4 *THIS, )
endi

interface IDebugSymbols5 extends IDebugSymbols4
  GUID				C65FA83E-1E69-475E-8E0E-B5D79E9CC17E
  dUMMY 			stdmethod(IDebugSymbols5 *THIS, )
endi

interface IDebugSystemObjects extends IUnknown
  GUID					6B86FE2C-2C4F-4F0C-9DA2-174311ACC327
  GetEventThread			stdmethod(IDebugSystemObjects *THIS, OUT PULONG Id)
  GetEventProcess			stdmethod(IDebugSystemObjects *THIS, OUT PULONG Id)
  GetCurrentThreadId			stdmethod(IDebugSystemObjects *THIS, OUT PULONG Id)
  SetCurrentThreadId			stdmethod(IDebugSystemObjects *THIS, IN ULONG Id)
  GetCurrentProcessId			stdmethod(IDebugSystemObjects *THIS, OUT PULONG Id)
  SetCurrentProcessId			stdmethod(IDebugSystemObjects *THIS, IN ULONG Id)
  GetNumberThreads			stdmethod(IDebugSystemObjects *THIS, OUT PULONG Number)
  GetTotalNumberThreads 		stdmethod(IDebugSystemObjects *THIS, OUT PULONG Total, OUT PULONG LargestProcess)
  GetThreadIdsByIndex			stdmethod(IDebugSystemObjects *THIS, IN ULONG Start, IN ULONG Count, OUT OPTIONAL PULONG Ids, OUT OPTIONAL PULONG SysIds)
  GetThreadIdByProcessor		stdmethod(IDebugSystemObjects *THIS, IN ULONG Processor, OUT PULONG Id)
  GetCurrentThreadDataOffset		stdmethod(IDebugSystemObjects *THIS, OUT PULONG64 Offset)
  GetThreadIdByDataOffset		stdmethod(IDebugSystemObjects *THIS, IN ULONG64 Offset, OUT PULONG Id)
  GetCurrentThreadTeb			stdmethod(IDebugSystemObjects *THIS, OUT PULONG64 Offset)
  GetThreadIdByTeb			stdmethod(IDebugSystemObjects *THIS, IN ULONG64 Offset, OUT PULONG Id)
  GetCurrentThreadSystemId		stdmethod(IDebugSystemObjects *THIS, OUT PULONG SysId)
  GetThreadIdBySystemId 		stdmethod(IDebugSystemObjects *THIS, IN ULONG SysId, OUT PULONG Id)
  GetCurrentThreadHandle		stdmethod(IDebugSystemObjects *THIS, OUT PULONG64 Handle)
  GetThreadIdByHandle			stdmethod(IDebugSystemObjects *THIS, IN ULONG64 Handle, OUT PULONG Id)
  GetNumberProcesses			stdmethod(IDebugSystemObjects *THIS, OUT PULONG Number)
  GetProcessIdsByIndex			stdmethod(IDebugSystemObjects *THIS, IN ULONG Start, IN ULONG Count, OUT OPTIONAL PULONG Ids, OUT OPTIONAL PULONG SysIds)
  GetCurrentProcessDataOffset		stdmethod(IDebugSystemObjects *THIS, OUT PULONG64 Offset)
  GetProcessIdByDataOffset		stdmethod(IDebugSystemObjects *THIS, IN ULONG64 Offset, OUT PULONG Id)
  GetCurrentProcessPeb			stdmethod(IDebugSystemObjects *THIS, OUT PULONG64 Offset)
  GetProcessIdByPeb			stdmethod(IDebugSystemObjects *THIS, IN ULONG64 Offset, OUT PULONG Id)
  GetCurrentProcessSystemId		stdmethod(IDebugSystemObjects *THIS, OUT PULONG SysId)
  GetProcessIdBySystemId		stdmethod(IDebugSystemObjects *THIS, IN ULONG SysId, OUT PULONG Id)
  GetCurrentProcessHandle		stdmethod(IDebugSystemObjects *THIS, OUT PULONG64 Handle)
  GetProcessIdByHandle			stdmethod(IDebugSystemObjects *THIS, IN ULONG64 Handle, OUT PULONG Id)
  GetCurrentProcessExecutableName	stdmethod(IDebugSystemObjects *THIS, OUT OPTIONAL PSTR Buffer, IN ULONG BufferSize, OUT OPTIONAL PULONG ExeSize)
endi

interface IDebugSystemObjects2 extends IDebugSystemObjects
  GUID				0AE9F5FF-1852-4679-B055-494BEE6407EE
  GetCurrentProcessUpTime	stdmethod(IDebugSystemObjects2 *THIS, OUT PULONG UpTime)
  GetImplicitThreadDataOffset	stdmethod(IDebugSystemObjects2 *THIS, OUT PULONG64 Offset)
  SetImplicitThreadDataOffset	stdmethod(IDebugSystemObjects2 *THIS, IN ULONG64 Offset)
  GetImplicitProcessDataOffset	stdmethod(IDebugSystemObjects2 *THIS, OUT PULONG64 Offset)
  SetImplicitProcessDataOffset	stdmethod(IDebugSystemObjects2 *THIS, IN ULONG64 Offset)
endi

interface IDebugSystemObjects3 extends IDebugSystemObjects2
  GUID				E9676E2F-E286-4EA3-B0F9-DFE5D9FC330E
  DUMMY 			stdmethod(IDebugSystemObjects3 *THIS, )
endi

interface IDebugSystemObjects4 extends IDebugSystemObjects3
  GUID				489468E6-7D0F-4AF5-87AB-25207454D553
  DUMMY 			stdmethod(IDebugSystemObjects4 *THIS, )
endi

